%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Projeto de controlador LAG
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Modelo da Planta:
%    G(s) = k/s(s+a)
%
% Especificaes de desempenho:
%   kvd  = 20        (constante de erro de velocidade)  
%   manter uf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Autor: Prof. Davi Antonio dos Santos (davists@ita.br)
%        Instituto Tecnolgico de Aeronautica
%        www.mec.ita.br/~davists 
%        06/05/2014
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

%% Dados

% Modelo da planta
k = 2;
a = 1;

num = k;
den = [1 a 0];
G = tf(num,den);


% Especificaes de desempenho
kv_ = k/a
kvd = kv_*10


% Plotar o diagrama de Bode do sistema no compensado
figure; margin(G);



%% Projeto do Controlador

% 1. Ganho de altas frequncias do controlador:
kc = 1;

% 2. Calcule o ganho de baixas frequncias do contrlador:
kbf = a/k*kvd;


% 3. Calcule k_til:
k_til = kbf;

% 4. Escolha bc < wcg/100:
bc = input('bc < wcg/100: ');

% 5. Calcule ac:
ac = bc/k_til;


%% Verificao da margem de fase
num = conv([kc kc*bc],[k]);
den = conv([1 ac], [1 a 0]);
CG = tf(num,den);
figure; margin(CG);
figure; nyquist(CG); hold; nyquist(G);
%% Verificao do kv
kv = kc*bc*k/(ac*a)











