%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Projeto de controlador LEAD
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Modelo da Planta:
%    G(s) = k/s(s+a)
%
% Especificaes de desempenho:
%    u_fd = 60 graus  (margem de fase)
%    kvd = 20         (constante de erro de velocidade)    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Autor: Prof. Davi Antonio dos Santos (davists@ita.br)
%        Instituto Tecnolgico de Aeronautica
%        www.mec.ita.br/~davists 
%        06/05/2014
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

%% Dados

% Modelo da planta
k = 2;
a = 1;

num = k;
den = [1 a 0];
G = tf(num,den);


% Especificaes de desempenho
ufd = 60;
kvd = 20;


% Plotar o diagrama de Bode do sistema no compensado
figure; margin(G);
kv = k/a



%% Projeto do Controlador

% 1. Calcule o ganho de baixas frequncias do controlador:
kbf = a/k*kvd;

% 2. Calcule a deficincia angular:
[ug,uf,wcg,wcf] = margin(kbf*G);
d = ufd - uf + 6;

% 3. Calcule k_til:
k_til = (1 - sind(d))/(1 + sind(d));

% 4. Calcule o ganho de altas frequncias do controlador:
kc = kbf/k_til;

% 5. Obtenha a nova frequncia de cruzamento de ganho:

NdB = 20*log10(kc*sqrt(k_til));
mG_jwcgN = -NdB
wcgN = input('wcnN:'); % leia a frequncia wcgN


% 6. Calcule ac e bc:
wm = wcgN;
ac = wm/sqrt(k_til);
bc = k_til*ac;


%% Verificao da margem de fase
num = conv([kc kc*bc],[k]);
den = conv([1 ac], [1 a 0]);
CG = tf(num,den);
margin(CG);
%% Verificao do kv
kv = kc*bc*k/(ac*a)











